package celular;

/**
 * Universidade Federal de Pernambuco
 * Centro de Informtica
 * Disciplina: Introducao a Programao
 * Projeto Celular
 *
 * Tipo: IPrevisaoTexto
 *
 * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
 * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
 * @author: Milena Rocha Leite          (mrl@cin.ufpe.br)  
 *
 * @since 2002
 * @version 1.0
 */

import celular.palavras.Palavra;
import celular.palavras.ListaPalavras;

public interface IPrevisaoTexto {

/**
 * Mtodo que exclui um palavra do dicionario
 *
 * @param Palavra  palavra a ser excluida do dicionario
 */
public void excluir(Palavra palavra);
/**
 * Mtodo que verifica se uma palavra existe no dicionario
 *
 * @param  Palavra  palavra a ser procurada
 *
 * @return boolean  indica se a palvra existe ou nao
 */
public boolean existe(Palavra palavra);
/**
 * Mtodo que retorna todas as palavras do dicionario que possuem uma das
 * letras passadas da posicao indicada
 *
 * @param  char[]         characteres a serem verificados
 * @return ListaPalavras  lista de palavras que possuem um dos caracteres
 *                          passados
 */
public ListaPalavras filtrar(char[] letras,int posicaoAtual);
/**
 * Mtodo que insere uma palavra na colecao
 *
 * @param Palvra   plavra a ser inserida
 */
public void inserir(Palavra palavra);
}
