package celular.interfaceTextual;

/**
  * Universidade Federal de Pernambuco
  * Centro de Informtica
  * Disciplina: Introducao a Programao
  * Projeto Celular
  *
  * Tipo: InterfaceUsuario
  *
  * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
  * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
  * @author: Milena Rocha Leite          (mrl@cin.ufpe.br)    
  *
  * @since 2002
  * @version 1.0
  **/

import celular.IPrevisaoTexto;
import celular.PrevisaoTexto;
import celular.palavras.CadastroPalavras;
import celular.palavras.ListaPalavras;
import celular.palavras.Palavra;
import celular.util.Console;

public class InterfacePrevisaoTexto {

   private IPrevisaoTexto celular;

   InterfacePrevisaoTexto () {
		ListaPalavras l = new ListaPalavras();
		String palavras[] = { "abri", "cesar", "ajuda", "aliado", "casa", "bar", "barco",
		                    "belo", "bola",  "boneca", "branco","brasil","cabelo",
		                    "carro", "castelo" ,"dama","data", "duvida", "elefante",
		                    "errado","errar","escola","familia","farmacia", "fonte",
		                     "formiga","foto","funeral","futebol","gabarito","gaiola",
		                    "garfo","gordo","grafico","grupo","guarda","guerra","habito",
		                    "haver","hematoma","heroi","hipotese","historia","homem",
		                    "hora","humano","ideal","igual","imaginacao","imobiliaria",
		                     "impessoal","indice","ingles","invalido","jacare","jogo",
		                      "justica","lado","lago","lanterna","lei","limao", "limite",
		                      "limpo","livre","livro","lobo","louco","luxo","macaco","machado",
		                      "maior","manga","maracuja","marinheiro","matematica","matricula",
		                     "medico","menor","mensagem","mundo","navio","nordeste","normal",
		                     "objeto","oficial","pacote","palhaco","papel","paulo","peixe",
		                     "queijo", "quinta","radio", "rato","sinal","sistema","tabela",
		                      "teclado", "uva","unidade", "vacina","vela", "vidro","watt",
		                      "xeque","xerox","you", "zebra", "zona", "vitoria"};
		for (int i=0; i<111; i++){
		   l.inserir(new Palavra(palavras[i]));
		}
		celular = new PrevisaoTexto(new CadastroPalavras(l));
  }        
public char[] caracteresDoDigito(int digito){
  char[] caracteres = null;
  switch (digito) {
	case 1:
	  char[] c1 = {'a','b','c'};
	  caracteres = c1;
	  break;
	case 2:
	  char[] c2 = {'d','e','f'};
	  caracteres = c2;
	  break;
	case 3:
	  char[] c3 = {'g','h','i'};
	  caracteres = c3;
	  break;
	case 4:
	  char[] c4 = {'j','k','l'};
	  caracteres = c4;
	  break;
	case 5:
	  char[] c5 = {'m','n','o'};
	  caracteres = c5;
	  break;
	case 6:
	  char[] c6 = {'p','q','r'};
	  caracteres = c6;
	  break;
	case 7:
	  char[] c7 = {'s','t','u'};
	  caracteres = c7;
	  break;
	case 8:
	  char[] c8 = {'v','w','x'};
	  caracteres = c8;
	  break;
	case 9:
	  char[] c9 = {'y','z'};
	  caracteres = c9;
	  break;
  }
  return caracteres;
}
public static void main(String args[]) {
	InterfacePrevisaoTexto i = new InterfacePrevisaoTexto();
	Console io = new Console();
	io.println("*************************************************************"
				+ "*********");
	io.println("\t\tCin - Centro de informatica UFPE");
	io.println("*************************************************************"
				+ "*********");
	io.println("\n   Esse Programa tem por proposito simular um Sistema de um" +
			   " Celular\n\n\nCada tecla do teclado numerico corresponde"+
				" a tres letras do alfabeto:");
	io.println("-------------------------------------------------------------"
				+ "---------");
	io.println(" 1 \t 2 \t 3 \t 4 \t 5 \t 6 \t 7 \t 8 \t 9 ");
	io.println("abc\tdef\tghi\tjkl\tmno\tpqr\tstu\tvwx\tyz");
	io.println("-------------------------------------------------------------"
				+ "---------");
	while (true) {
	io.print("\n\nDigite um numero para pesquisar a palavra:  ");
	String pesq = io.readString();
	ListaPalavras p = i.preverTexto(pesq);

	io.println("\n\nResultado da Pesquisa:\n");

	p.reset();
	Palavra p2 = p.proxima();
	if(p.getTamanho() > 0){
		while(p2 != null){
			io.println("\t" + p2.getPalavra());
			p2 = p.proxima();
	   	}
	} else {
		io.println("\n\t!!Nenhuma palavra foi encontrada!!");
	}
	}
  }            
   /**
	* Metodo que retorna um vocabulario filtrado
	* de acordo com um codigo numerico
	* @param tecla          recebe o codigo numerico
	* @return pesquisa      do tipo vocabulario
	**/
   private ListaPalavras preverTexto(String numeroDigitado){
	  String resto = numeroDigitado;
	  int digito = -1;
	  int posicaoDoDigito = 0;
	  ListaPalavras previsao = null;

	  while (resto.length() >= 1) {
		digito = Integer.parseInt(resto.substring(0,1));
		posicaoDoDigito = posicaoDoDigito + 1;
		resto = resto.substring(1);
		if (posicaoDoDigito == 1) {
		  previsao = celular.filtrar(caracteresDoDigito(digito),posicaoDoDigito);
		} else {
		  previsao = previsao.filtrar(caracteresDoDigito(digito),posicaoDoDigito);
		}
	  }
	  return previsao;
	}
}
