package celular.palavras;

/**
  * Universidade Federal de Pernambuco
  * Centro de Informtica
  * Disciplina: Introducao a Programao
  * Projeto Celular
  *
  * Tipo:Palavra
  *
  * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
  * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
  * @author: Milena Rocha                (mrl@cin.ufpe.br)  
  *
  * @since 2002
  * @version 1.1
  **/

import celular.util.Console;

public class Palavra {

  private String palavra;
  private Console c;
  
  /** 
   * Construtor da classe palavra
   *
   */
  public Palavra(String palavra) {
	if (palavra != null) {
		
	   this.palavra = palavra;
	   this.c = new Console();
	   
	} else {
		c.println("ERRO: a palavra passada como parametro eh nula");
	}
  }          
  /**
   * Mtodo para a verificao de igualdade entre duas palavras
   *
   * @param  Palavra  palavra a ser comparada
   * @return boolean  boleano que indica se a palavra que chama o mtodo  igual
   *                  a palavra passada como parmetro
   */
  public boolean equals(Object palavra){
	boolean retorno = false;
	Palavra pal = null;

	if(palavra != null) {
		if( palavra instanceof Palavra){
			pal = (Palavra)palavra;
			if (pal.getPalavra().equalsIgnoreCase(this.getPalavra())){
				  retorno = true;
			}
		}
	}	
	return retorno;
 }    
 /** 
  * Mtodo que retorna a letra que esta na posio
  * passada como parametro
  *
  * @param  int           posio da letra procurada
  * @return char          retorna letra encontrada
  */
 private char getLetra(int posicao){
 	char letra = '\n';

 	if(posicao >= 1) {
	 	if(posicao <= this.palavra.length()) {
	 		letra = this.palavra.charAt(posicao-1);
	 	}
 	} 	
 	return letra;
 }    
  /**
   * Mtodo que retorna a palavra propriamente dita(o string)
   *
   * @return String palavra
   */
  public String getPalavra(){
	return this.palavra;
  }

  
 //main para verificacao de alguns metodos
 public static void main(String args[]){
		Console c = new Console();
 	Palavra p = new Palavra("xzracaju");
 	c.println(p.getLetra(2));
 } 
/**
 * Mtodo que atrinui um novo valor ao atributo palavra
 *
 * @param String nova palavra a ser alterada
 */
public void setPalavra(String palavra) {
 	
	if(palavra != null) {
		this.palavra = palavra;
	} else{
		c.println("A palavra passada estah nula");
	}		

 } 
  /**
   * Mtodo que verifica se a palavra possui em determinada posicao um dos
   * caracteres passados
   *
   * @return boolean	informa se a palavra possui essa letra na posio
   */
 public boolean temLetras(char[] letras,int posicao) {
 	
	 boolean retorno = false;
	 char l;
	 
	 if(posicao >= 1) {
	 	l = this.getLetra(posicao);
	
	 	if (l!='\n') {
	 	  for (int i = 0; i < letras.length; i++) {
				retorno = retorno || (l == letras[i]);
		  }
	 	}
	 }
 	return retorno;
 }       
}
